/*
 * input.h: header for input.c 
 *
 * Written By Michael Sandrof
 *
 * Copyright(c) 1990 
 *
 * See the COPYRIGHT file, or do a HELP IRCII COPYRIGHT 
 *
 * @(#)$Id: input.h,v 1.4 1994/07/02 02:38:10 mrg Exp $
 */

#ifndef _INPUT_H_
#define _INPUT_H_

extern	char	input_pause _((char *));
extern	void	set_input _((char *));
extern	void	set_input_prompt _((char *));
extern	char	*get_input_prompt _((void));
extern	char	*get_input _((void));
extern	void	update_input _((int));
extern	void	init_input _((void));
extern	void	input_move_cursor _((int));
extern	void	change_input_prompt _((int));
extern	void	cursor_to_input _((void));
extern	void	refresh_inputline _((void));
extern	void	input_forward_word _((void));
extern	void	input_backward_word _((void));
extern	void	input_delete_character _((void));
extern	void	input_backspace _((char, char *));
extern	void	input_beginning_of_line _((void));
extern	void	input_end_of_line _((void));
extern	void	input_delete_previous_word _((void));
extern	void	input_delete_next_word _((void));
extern	void	input_add_character _((char, char *));
extern	void	set_input _((char *));
extern	char	*get_input _((void));
extern	void	input_clear_to_eol _((void));
extern	void	input_clear_to_bol _((void));
extern	void	input_clear_line _((void));
extern  void	input_transpose_characters _((void));
extern	void	init_input _((void));
extern	void	input_yank_cut_buffer _((void));
extern	char	*get_input_prompt _((void));
extern	void	set_input_prompt _((char *));
extern	char	input_pasue _((char *));


/* used by update_input */
#define NO_UPDATE 0
#define UPDATE_ALL 1
#define UPDATE_FROM_CURSOR 2
#define UPDATE_JUST_CURSOR 3

#endif /* _INPUT_H_ */
