/*
 * Queue.h - header file for queue.c
 *
 * ircII - written by Michael Sandroff
 * (C) 1990 - 1994
 *
 * queue.c, queue.h written 1993 Jeremy Nelson
 *
 * See the coypright file for more information
 */

#ifndef QueueH
#define QueueH

#include "irc_std.h"

struct CmdListT;
struct  QueueT {
        struct QueueT   *next;
        struct CmdListT *first;
        char     *name;
};
struct  CmdListT {
        struct CmdListT *next;
        char     *what;
};
typedef struct QueueT Queue;
typedef struct CmdListT CmdList;

void    queuecmd _((char *, char *, char *));
Queue   *lookup_queue _((Queue *, char *));
int     add_commands_to_queue _((Queue *, char *, char *));
void    display_all_queues _((Queue *));
CmdList *walk_commands _((Queue *));
Queue   *make_new_queue _((Queue *, char *));
int     delete_commands_from_queue _((Queue *, int));
void    flush_queue _((Queue *));
void    print_queue _((Queue *));
int     num_entries _((Queue *));
Queue   *remove_a_queue _((Queue *));
Queue   *do_queue _((Queue *, int));

#endif
