/*
 * words.c -- right now it just holds the stuff i wrote to replace
 * that beastie arg_number().  Eventually, i may move all of the
 * word functions out of ircaux and into here.  Now wouldnt that
 * be a beastie of a patch! Beastie! Beastie!
 *
 * Oh yea.  This file is copyrighted (C) 1994 by the beastie author.
 * Right now the only author is Jeremy "Beastie" Nelson. That may 
 * change pretty beastie soon.
 */

#include "irc.h"
#include "ircaux.h"

/*
 * search() looks for a character forward or backward from mark 
 */
#ifdef __STDC__
char	*search(char *start, char **mark, char *chars, int how)
#else
char *search(start, mark, chars, how)
char *start;
char **mark;
char *chars;
int how;
#endif
{
        if (!mark || !*mark)
                *mark = start;

        if (how > 0)   /* forward search */
        {
		int counter = how;
		/* loop has to be unrolled once in case the first
		   characters is one we are looking for */
		*mark = sindex(*mark, chars);
		counter--;
		for (;counter > 0;counter--)
		{
                	*mark = sindex(*mark+1, chars);
			if (!*mark || !**mark)
				break;
		}
	}
	else if (how == 0)
		return (char *) 0;
	else  /* how < 0 */
	{
		int counter = how;
		*mark = rsindex(*mark, start, chars);
		counter++;
		for (;counter < 0;counter++)
		{
			*mark = rsindex(*mark-1, start, chars);
			if (!*mark || !**mark)
				break;
		}
	}
	return *mark;
}

#ifdef __STDC__
char	*move_up_word (char *word)
#else
char *move_up_word (word)
char *word;
#endif
{
	char *beastie;
	beastie = sindex(word, "^ \t\n");
	beastie = sindex(beastie, " \t\n");
	beastie = sindex(beastie, "^ \t\n");
	return beastie;
}

#ifdef __STDC__
char	*move_back_word (char *word)
#else
char *move_back_word (word)
char *word;
#endif
{
	while ((*word == '\t') || (*word == ' ') || (*word == '\n'))
		word--;
	while ((*word != '\t') && (*word != ' ') && (*word != '\n'))
		word--;
	return word;
}

/* Move to an absolute word number from start */
/* First word is always numbered zero. */
#ifdef __STDC__
char	*move_to_abs_word (char *start, char **mark, int word)
#else
char *move_to_abs_word(start, mark, word)
char *start;
char **mark;
int word;
#endif
{
	char *pointer = start;
	int counter = word;

	for (;counter > 0 && *pointer;counter--)
	{
		while (*pointer && !isspace(*pointer))
			pointer++;
		while (*pointer && isspace(*pointer))
			pointer++;
	}

	if (mark)
		*mark = pointer;
	return pointer;
}

/* Move a relative number of words from the present mark */
#ifdef __STDC__
char	*move_word_rel (char *start, char **mark, int word)
#else
char *move_word_rel(start, mark, word)
char *start;
char **mark;
int word;
#endif
{
	char *pointer = *mark;
	int counter = word;
	char *end = start + strlen(start);

	if (end == start) 	/* null string, return it */
		return start;

	if (end == *mark)	/* just in case */
		mark--;

	if (counter > 0)
	{
		for (;counter > 0 && pointer;counter--)
		{
			while (*pointer && !isspace(*pointer))
				pointer++;
			while (*pointer && isspace(*pointer)) 
				pointer++;
		}
	}
	else if (counter == 0)
		pointer = *mark;
	else if (counter < 0)
	{
		for (;counter < 0 && pointer > start;counter++)
		{
			while (pointer >= start && isspace(*pointer))
				pointer--;
			while (pointer >= start && !isspace(*pointer))
				pointer--;
		}
		pointer++; /* bump up to the word we just passed */
	}

	if (mark)
		*mark = pointer;
	return pointer;
}

/* Much simpler, much less error prone way to extract words from a string.
 */
#ifdef __STDC__
char	*extract(char *start, int firstword, int lastword)
#else
char *extract(start, firstword, lastword)
char *start;
int  firstword;
int  lastword;
#endif
{
	/* If firstword or lastword is negative, then
	   we take those values from the end of the string */
	char *mark;
	char *mark2;
	char *booya = (char *) 0;

	/* If the firstword is positive, move to that word */
	if (firstword >= 0)
		move_to_abs_word(start, &mark, firstword);

	/* Otherwise, move to the firstwords from the end */
	else
	{
		mark = start + strlen(start);
		mark = move_word_rel(start, &mark, firstword);
	}

	/* When we find the last word, we need to move to the 
           END of the word, so that word 3 to 3, would include
	   all of word 3, so we sindex to the space after the word
 	 */
	/* EOS is a #define meaning "end of string" */
	if (lastword == EOS)
		mark2 = start + strlen(start);
	else 
	{
		if (lastword >= 0)
			move_to_abs_word(start, &mark2, lastword+1);
		else
		{
			mark2 = start + strlen(start);
			move_word_rel(start, &mark2, lastword);
		}
		while (mark2 > start && isspace(mark2[-1]))
			mark2--;
	}

	/* If the end is before the string, then there is nothing
	 * to extract (this is perfectly legal, btw)
         */
	if (mark2 < mark)
		malloc_strcpy(&booya, empty_string);
	else
	{
		/* Otherwise, copy off the string we just isolated */ 
		char tmp;
		tmp = *mark2;
		*mark2 = '\0';
		malloc_strcpy(&booya, mark);
		*mark2 = tmp;
	}
	return booya;
}


